// Code generated by protoc-gen-go. DO NOT EDIT.
// versions:
// 	protoc-gen-go v1.34.2
// 	protoc        v3.21.12
// source: yandex/cloud/lockbox/v1/secret.proto

package lockbox

import (
	_ "github.com/yandex-cloud/go-genproto/yandex/cloud"
	protoreflect "google.golang.org/protobuf/reflect/protoreflect"
	protoimpl "google.golang.org/protobuf/runtime/protoimpl"
	timestamppb "google.golang.org/protobuf/types/known/timestamppb"
	wrapperspb "google.golang.org/protobuf/types/known/wrapperspb"
	reflect "reflect"
	sync "sync"
)

const (
	// Verify that this generated code is sufficiently up-to-date.
	_ = protoimpl.EnforceVersion(20 - protoimpl.MinVersion)
	// Verify that runtime/protoimpl is sufficiently up-to-date.
	_ = protoimpl.EnforceVersion(protoimpl.MaxVersion - 20)
)

type Secret_Status int32

const (
	Secret_STATUS_UNSPECIFIED Secret_Status = 0
	// The secret is being created.
	Secret_CREATING Secret_Status = 1
	// The secret is active and the secret payload can be accessed.
	//
	// Can be set to INACTIVE using the [SecretService.Deactivate] method.
	Secret_ACTIVE Secret_Status = 2
	// The secret is inactive and unusable.
	//
	// Can be set to ACTIVE using the [SecretService.Deactivate] method.
	Secret_INACTIVE Secret_Status = 3
)

// Enum value maps for Secret_Status.
var (
	Secret_Status_name = map[int32]string{
		0: "STATUS_UNSPECIFIED",
		1: "CREATING",
		2: "ACTIVE",
		3: "INACTIVE",
	}
	Secret_Status_value = map[string]int32{
		"STATUS_UNSPECIFIED": 0,
		"CREATING":           1,
		"ACTIVE":             2,
		"INACTIVE":           3,
	}
)

func (x Secret_Status) Enum() *Secret_Status {
	p := new(Secret_Status)
	*p = x
	return p
}

func (x Secret_Status) String() string {
	return protoimpl.X.EnumStringOf(x.Descriptor(), protoreflect.EnumNumber(x))
}

func (Secret_Status) Descriptor() protoreflect.EnumDescriptor {
	return file_yandex_cloud_lockbox_v1_secret_proto_enumTypes[0].Descriptor()
}

func (Secret_Status) Type() protoreflect.EnumType {
	return &file_yandex_cloud_lockbox_v1_secret_proto_enumTypes[0]
}

func (x Secret_Status) Number() protoreflect.EnumNumber {
	return protoreflect.EnumNumber(x)
}

// Deprecated: Use Secret_Status.Descriptor instead.
func (Secret_Status) EnumDescriptor() ([]byte, []int) {
	return file_yandex_cloud_lockbox_v1_secret_proto_rawDescGZIP(), []int{0, 0}
}

type Version_Status int32

const (
	Version_STATUS_UNSPECIFIED Version_Status = 0
	// The version is active and the secret payload can be accessed.
	Version_ACTIVE Version_Status = 1
	// The version is scheduled for destruction, the time when it will be destroyed
	// is specified in the [Version.destroy_at] field.
	Version_SCHEDULED_FOR_DESTRUCTION Version_Status = 2
	// The version is destroyed and cannot be recovered.
	Version_DESTROYED Version_Status = 3
)

// Enum value maps for Version_Status.
var (
	Version_Status_name = map[int32]string{
		0: "STATUS_UNSPECIFIED",
		1: "ACTIVE",
		2: "SCHEDULED_FOR_DESTRUCTION",
		3: "DESTROYED",
	}
	Version_Status_value = map[string]int32{
		"STATUS_UNSPECIFIED":        0,
		"ACTIVE":                    1,
		"SCHEDULED_FOR_DESTRUCTION": 2,
		"DESTROYED":                 3,
	}
)

func (x Version_Status) Enum() *Version_Status {
	p := new(Version_Status)
	*p = x
	return p
}

func (x Version_Status) String() string {
	return protoimpl.X.EnumStringOf(x.Descriptor(), protoreflect.EnumNumber(x))
}

func (Version_Status) Descriptor() protoreflect.EnumDescriptor {
	return file_yandex_cloud_lockbox_v1_secret_proto_enumTypes[1].Descriptor()
}

func (Version_Status) Type() protoreflect.EnumType {
	return &file_yandex_cloud_lockbox_v1_secret_proto_enumTypes[1]
}

func (x Version_Status) Number() protoreflect.EnumNumber {
	return protoreflect.EnumNumber(x)
}

// Deprecated: Use Version_Status.Descriptor instead.
func (Version_Status) EnumDescriptor() ([]byte, []int) {
	return file_yandex_cloud_lockbox_v1_secret_proto_rawDescGZIP(), []int{1, 0}
}

// A secret that may contain several versions of the payload.
type Secret struct {
	state         protoimpl.MessageState
	sizeCache     protoimpl.SizeCache
	unknownFields protoimpl.UnknownFields

	// ID of the secret.
	Id string `protobuf:"bytes,1,opt,name=id,proto3" json:"id,omitempty"`
	// ID of the folder that the secret belongs to.
	FolderId string `protobuf:"bytes,2,opt,name=folder_id,json=folderId,proto3" json:"folder_id,omitempty"`
	// Creation timestamp.
	CreatedAt *timestamppb.Timestamp `protobuf:"bytes,3,opt,name=created_at,json=createdAt,proto3" json:"created_at,omitempty"`
	// Name of the secret.
	Name string `protobuf:"bytes,4,opt,name=name,proto3" json:"name,omitempty"`
	// Description of the secret.
	Description string `protobuf:"bytes,5,opt,name=description,proto3" json:"description,omitempty"`
	// Custom labels for the secret as `key:value` pairs. Maximum 64 per key.
	Labels map[string]string `protobuf:"bytes,6,rep,name=labels,proto3" json:"labels,omitempty" protobuf_key:"bytes,1,opt,name=key,proto3" protobuf_val:"bytes,2,opt,name=value,proto3"`
	// Optional ID of the KMS key will be used to encrypt and decrypt the secret.
	KmsKeyId string `protobuf:"bytes,7,opt,name=kms_key_id,json=kmsKeyId,proto3" json:"kms_key_id,omitempty"`
	// Status of the secret.
	Status Secret_Status `protobuf:"varint,8,opt,name=status,proto3,enum=yandex.cloud.lockbox.v1.Secret_Status" json:"status,omitempty"`
	// Current (i.e. the `latest`) version of the secret.
	CurrentVersion *Version `protobuf:"bytes,9,opt,name=current_version,json=currentVersion,proto3" json:"current_version,omitempty"`
	// Flag that inhibits deletion of the secret.
	DeletionProtection bool `protobuf:"varint,10,opt,name=deletion_protection,json=deletionProtection,proto3" json:"deletion_protection,omitempty"`
	// Types that are assignable to PayloadSpecification:
	//
	//	*Secret_PasswordPayloadSpecification
	PayloadSpecification isSecret_PayloadSpecification `protobuf_oneof:"payload_specification"`
}

func (x *Secret) Reset() {
	*x = Secret{}
	if protoimpl.UnsafeEnabled {
		mi := &file_yandex_cloud_lockbox_v1_secret_proto_msgTypes[0]
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		ms.StoreMessageInfo(mi)
	}
}

func (x *Secret) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*Secret) ProtoMessage() {}

func (x *Secret) ProtoReflect() protoreflect.Message {
	mi := &file_yandex_cloud_lockbox_v1_secret_proto_msgTypes[0]
	if protoimpl.UnsafeEnabled && x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use Secret.ProtoReflect.Descriptor instead.
func (*Secret) Descriptor() ([]byte, []int) {
	return file_yandex_cloud_lockbox_v1_secret_proto_rawDescGZIP(), []int{0}
}

func (x *Secret) GetId() string {
	if x != nil {
		return x.Id
	}
	return ""
}

func (x *Secret) GetFolderId() string {
	if x != nil {
		return x.FolderId
	}
	return ""
}

func (x *Secret) GetCreatedAt() *timestamppb.Timestamp {
	if x != nil {
		return x.CreatedAt
	}
	return nil
}

func (x *Secret) GetName() string {
	if x != nil {
		return x.Name
	}
	return ""
}

func (x *Secret) GetDescription() string {
	if x != nil {
		return x.Description
	}
	return ""
}

func (x *Secret) GetLabels() map[string]string {
	if x != nil {
		return x.Labels
	}
	return nil
}

func (x *Secret) GetKmsKeyId() string {
	if x != nil {
		return x.KmsKeyId
	}
	return ""
}

func (x *Secret) GetStatus() Secret_Status {
	if x != nil {
		return x.Status
	}
	return Secret_STATUS_UNSPECIFIED
}

func (x *Secret) GetCurrentVersion() *Version {
	if x != nil {
		return x.CurrentVersion
	}
	return nil
}

func (x *Secret) GetDeletionProtection() bool {
	if x != nil {
		return x.DeletionProtection
	}
	return false
}

func (m *Secret) GetPayloadSpecification() isSecret_PayloadSpecification {
	if m != nil {
		return m.PayloadSpecification
	}
	return nil
}

func (x *Secret) GetPasswordPayloadSpecification() *PasswordPayloadSpecification {
	if x, ok := x.GetPayloadSpecification().(*Secret_PasswordPayloadSpecification); ok {
		return x.PasswordPayloadSpecification
	}
	return nil
}

type isSecret_PayloadSpecification interface {
	isSecret_PayloadSpecification()
}

type Secret_PasswordPayloadSpecification struct {
	PasswordPayloadSpecification *PasswordPayloadSpecification `protobuf:"bytes,11,opt,name=password_payload_specification,json=passwordPayloadSpecification,proto3,oneof"`
}

func (*Secret_PasswordPayloadSpecification) isSecret_PayloadSpecification() {}

type Version struct {
	state         protoimpl.MessageState
	sizeCache     protoimpl.SizeCache
	unknownFields protoimpl.UnknownFields

	// ID of the version.
	Id string `protobuf:"bytes,1,opt,name=id,proto3" json:"id,omitempty"`
	// ID of the secret that the version belongs to.
	SecretId string `protobuf:"bytes,2,opt,name=secret_id,json=secretId,proto3" json:"secret_id,omitempty"`
	// Time when the version was created.
	CreatedAt *timestamppb.Timestamp `protobuf:"bytes,3,opt,name=created_at,json=createdAt,proto3" json:"created_at,omitempty"`
	// Time when the version is going to be destroyed. Empty unless the status
	// is `SCHEDULED_FOR_DESTRUCTION`.
	DestroyAt *timestamppb.Timestamp `protobuf:"bytes,4,opt,name=destroy_at,json=destroyAt,proto3" json:"destroy_at,omitempty"`
	// Description of the version.
	Description string `protobuf:"bytes,5,opt,name=description,proto3" json:"description,omitempty"`
	// Status of the secret.
	Status Version_Status `protobuf:"varint,6,opt,name=status,proto3,enum=yandex.cloud.lockbox.v1.Version_Status" json:"status,omitempty"`
	// Keys of the entries contained in the version payload.
	PayloadEntryKeys []string `protobuf:"bytes,7,rep,name=payload_entry_keys,json=payloadEntryKeys,proto3" json:"payload_entry_keys,omitempty"`
	// Types that are assignable to PayloadSpecification:
	//
	//	*Version_PasswordPayloadSpecification
	PayloadSpecification isVersion_PayloadSpecification `protobuf_oneof:"payload_specification"`
}

func (x *Version) Reset() {
	*x = Version{}
	if protoimpl.UnsafeEnabled {
		mi := &file_yandex_cloud_lockbox_v1_secret_proto_msgTypes[1]
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		ms.StoreMessageInfo(mi)
	}
}

func (x *Version) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*Version) ProtoMessage() {}

func (x *Version) ProtoReflect() protoreflect.Message {
	mi := &file_yandex_cloud_lockbox_v1_secret_proto_msgTypes[1]
	if protoimpl.UnsafeEnabled && x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use Version.ProtoReflect.Descriptor instead.
func (*Version) Descriptor() ([]byte, []int) {
	return file_yandex_cloud_lockbox_v1_secret_proto_rawDescGZIP(), []int{1}
}

func (x *Version) GetId() string {
	if x != nil {
		return x.Id
	}
	return ""
}

func (x *Version) GetSecretId() string {
	if x != nil {
		return x.SecretId
	}
	return ""
}

func (x *Version) GetCreatedAt() *timestamppb.Timestamp {
	if x != nil {
		return x.CreatedAt
	}
	return nil
}

func (x *Version) GetDestroyAt() *timestamppb.Timestamp {
	if x != nil {
		return x.DestroyAt
	}
	return nil
}

func (x *Version) GetDescription() string {
	if x != nil {
		return x.Description
	}
	return ""
}

func (x *Version) GetStatus() Version_Status {
	if x != nil {
		return x.Status
	}
	return Version_STATUS_UNSPECIFIED
}

func (x *Version) GetPayloadEntryKeys() []string {
	if x != nil {
		return x.PayloadEntryKeys
	}
	return nil
}

func (m *Version) GetPayloadSpecification() isVersion_PayloadSpecification {
	if m != nil {
		return m.PayloadSpecification
	}
	return nil
}

func (x *Version) GetPasswordPayloadSpecification() *PasswordPayloadSpecification {
	if x, ok := x.GetPayloadSpecification().(*Version_PasswordPayloadSpecification); ok {
		return x.PasswordPayloadSpecification
	}
	return nil
}

type isVersion_PayloadSpecification interface {
	isVersion_PayloadSpecification()
}

type Version_PasswordPayloadSpecification struct {
	PasswordPayloadSpecification *PasswordPayloadSpecification `protobuf:"bytes,8,opt,name=password_payload_specification,json=passwordPayloadSpecification,proto3,oneof"`
}

func (*Version_PasswordPayloadSpecification) isVersion_PayloadSpecification() {}

type PasswordPayloadSpecification struct {
	state         protoimpl.MessageState
	sizeCache     protoimpl.SizeCache
	unknownFields protoimpl.UnknownFields

	// key of the entry to store generated password value
	PasswordKey string `protobuf:"bytes,1,opt,name=password_key,json=passwordKey,proto3" json:"password_key,omitempty"`
	// password length; by default, a reasonable length will be decided
	Length int64 `protobuf:"varint,2,opt,name=length,proto3" json:"length,omitempty"`
	// whether at least one A..Z character is included in the password, true by default
	IncludeUppercase *wrapperspb.BoolValue `protobuf:"bytes,3,opt,name=include_uppercase,json=includeUppercase,proto3" json:"include_uppercase,omitempty"`
	// whether at least one a..z character is included in the password, true by default
	IncludeLowercase *wrapperspb.BoolValue `protobuf:"bytes,4,opt,name=include_lowercase,json=includeLowercase,proto3" json:"include_lowercase,omitempty"`
	// whether at least one 0..9 character is included in the password, true by default
	IncludeDigits *wrapperspb.BoolValue `protobuf:"bytes,5,opt,name=include_digits,json=includeDigits,proto3" json:"include_digits,omitempty"`
	// whether at least one punctuation character is included in the password, true by default
	// punctuation characters by default (there are 32): !"#$%&'()*+,-./:;<=>?@[\]^_`{|}~
	// to customize the punctuation characters, see included_punctuation and excluded_punctuation below
	IncludePunctuation *wrapperspb.BoolValue `protobuf:"bytes,6,opt,name=include_punctuation,json=includePunctuation,proto3" json:"include_punctuation,omitempty"`
	// If include_punctuation is true, one of these two fields (not both) may be used optionally to customize the punctuation:
	// a string of specific punctuation characters to use (at most, all the 32)
	IncludedPunctuation string `protobuf:"bytes,7,opt,name=included_punctuation,json=includedPunctuation,proto3" json:"included_punctuation,omitempty"`
	// a string of punctuation characters to exclude from the default (at most 31, it's not allowed to exclude all the 32)
	ExcludedPunctuation string `protobuf:"bytes,8,opt,name=excluded_punctuation,json=excludedPunctuation,proto3" json:"excluded_punctuation,omitempty"`
}

func (x *PasswordPayloadSpecification) Reset() {
	*x = PasswordPayloadSpecification{}
	if protoimpl.UnsafeEnabled {
		mi := &file_yandex_cloud_lockbox_v1_secret_proto_msgTypes[2]
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		ms.StoreMessageInfo(mi)
	}
}

func (x *PasswordPayloadSpecification) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*PasswordPayloadSpecification) ProtoMessage() {}

func (x *PasswordPayloadSpecification) ProtoReflect() protoreflect.Message {
	mi := &file_yandex_cloud_lockbox_v1_secret_proto_msgTypes[2]
	if protoimpl.UnsafeEnabled && x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use PasswordPayloadSpecification.ProtoReflect.Descriptor instead.
func (*PasswordPayloadSpecification) Descriptor() ([]byte, []int) {
	return file_yandex_cloud_lockbox_v1_secret_proto_rawDescGZIP(), []int{2}
}

func (x *PasswordPayloadSpecification) GetPasswordKey() string {
	if x != nil {
		return x.PasswordKey
	}
	return ""
}

func (x *PasswordPayloadSpecification) GetLength() int64 {
	if x != nil {
		return x.Length
	}
	return 0
}

func (x *PasswordPayloadSpecification) GetIncludeUppercase() *wrapperspb.BoolValue {
	if x != nil {
		return x.IncludeUppercase
	}
	return nil
}

func (x *PasswordPayloadSpecification) GetIncludeLowercase() *wrapperspb.BoolValue {
	if x != nil {
		return x.IncludeLowercase
	}
	return nil
}

func (x *PasswordPayloadSpecification) GetIncludeDigits() *wrapperspb.BoolValue {
	if x != nil {
		return x.IncludeDigits
	}
	return nil
}

func (x *PasswordPayloadSpecification) GetIncludePunctuation() *wrapperspb.BoolValue {
	if x != nil {
		return x.IncludePunctuation
	}
	return nil
}

func (x *PasswordPayloadSpecification) GetIncludedPunctuation() string {
	if x != nil {
		return x.IncludedPunctuation
	}
	return ""
}

func (x *PasswordPayloadSpecification) GetExcludedPunctuation() string {
	if x != nil {
		return x.ExcludedPunctuation
	}
	return ""
}

var File_yandex_cloud_lockbox_v1_secret_proto protoreflect.FileDescriptor

var file_yandex_cloud_lockbox_v1_secret_proto_rawDesc = []byte{
	0x0a, 0x24, 0x79, 0x61, 0x6e, 0x64, 0x65, 0x78, 0x2f, 0x63, 0x6c, 0x6f, 0x75, 0x64, 0x2f, 0x6c,
	0x6f, 0x63, 0x6b, 0x62, 0x6f, 0x78, 0x2f, 0x76, 0x31, 0x2f, 0x73, 0x65, 0x63, 0x72, 0x65, 0x74,
	0x2e, 0x70, 0x72, 0x6f, 0x74, 0x6f, 0x12, 0x17, 0x79, 0x61, 0x6e, 0x64, 0x65, 0x78, 0x2e, 0x63,
	0x6c, 0x6f, 0x75, 0x64, 0x2e, 0x6c, 0x6f, 0x63, 0x6b, 0x62, 0x6f, 0x78, 0x2e, 0x76, 0x31, 0x1a,
	0x1f, 0x67, 0x6f, 0x6f, 0x67, 0x6c, 0x65, 0x2f, 0x70, 0x72, 0x6f, 0x74, 0x6f, 0x62, 0x75, 0x66,
	0x2f, 0x74, 0x69, 0x6d, 0x65, 0x73, 0x74, 0x61, 0x6d, 0x70, 0x2e, 0x70, 0x72, 0x6f, 0x74, 0x6f,
	0x1a, 0x1d, 0x79, 0x61, 0x6e, 0x64, 0x65, 0x78, 0x2f, 0x63, 0x6c, 0x6f, 0x75, 0x64, 0x2f, 0x76,
	0x61, 0x6c, 0x69, 0x64, 0x61, 0x74, 0x69, 0x6f, 0x6e, 0x2e, 0x70, 0x72, 0x6f, 0x74, 0x6f, 0x1a,
	0x1e, 0x67, 0x6f, 0x6f, 0x67, 0x6c, 0x65, 0x2f, 0x70, 0x72, 0x6f, 0x74, 0x6f, 0x62, 0x75, 0x66,
	0x2f, 0x77, 0x72, 0x61, 0x70, 0x70, 0x65, 0x72, 0x73, 0x2e, 0x70, 0x72, 0x6f, 0x74, 0x6f, 0x22,
	0xe2, 0x05, 0x0a, 0x06, 0x53, 0x65, 0x63, 0x72, 0x65, 0x74, 0x12, 0x0e, 0x0a, 0x02, 0x69, 0x64,
	0x18, 0x01, 0x20, 0x01, 0x28, 0x09, 0x52, 0x02, 0x69, 0x64, 0x12, 0x1b, 0x0a, 0x09, 0x66, 0x6f,
	0x6c, 0x64, 0x65, 0x72, 0x5f, 0x69, 0x64, 0x18, 0x02, 0x20, 0x01, 0x28, 0x09, 0x52, 0x08, 0x66,
	0x6f, 0x6c, 0x64, 0x65, 0x72, 0x49, 0x64, 0x12, 0x39, 0x0a, 0x0a, 0x63, 0x72, 0x65, 0x61, 0x74,
	0x65, 0x64, 0x5f, 0x61, 0x74, 0x18, 0x03, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x1a, 0x2e, 0x67, 0x6f,
	0x6f, 0x67, 0x6c, 0x65, 0x2e, 0x70, 0x72, 0x6f, 0x74, 0x6f, 0x62, 0x75, 0x66, 0x2e, 0x54, 0x69,
	0x6d, 0x65, 0x73, 0x74, 0x61, 0x6d, 0x70, 0x52, 0x09, 0x63, 0x72, 0x65, 0x61, 0x74, 0x65, 0x64,
	0x41, 0x74, 0x12, 0x12, 0x0a, 0x04, 0x6e, 0x61, 0x6d, 0x65, 0x18, 0x04, 0x20, 0x01, 0x28, 0x09,
	0x52, 0x04, 0x6e, 0x61, 0x6d, 0x65, 0x12, 0x20, 0x0a, 0x0b, 0x64, 0x65, 0x73, 0x63, 0x72, 0x69,
	0x70, 0x74, 0x69, 0x6f, 0x6e, 0x18, 0x05, 0x20, 0x01, 0x28, 0x09, 0x52, 0x0b, 0x64, 0x65, 0x73,
	0x63, 0x72, 0x69, 0x70, 0x74, 0x69, 0x6f, 0x6e, 0x12, 0x43, 0x0a, 0x06, 0x6c, 0x61, 0x62, 0x65,
	0x6c, 0x73, 0x18, 0x06, 0x20, 0x03, 0x28, 0x0b, 0x32, 0x2b, 0x2e, 0x79, 0x61, 0x6e, 0x64, 0x65,
	0x78, 0x2e, 0x63, 0x6c, 0x6f, 0x75, 0x64, 0x2e, 0x6c, 0x6f, 0x63, 0x6b, 0x62, 0x6f, 0x78, 0x2e,
	0x76, 0x31, 0x2e, 0x53, 0x65, 0x63, 0x72, 0x65, 0x74, 0x2e, 0x4c, 0x61, 0x62, 0x65, 0x6c, 0x73,
	0x45, 0x6e, 0x74, 0x72, 0x79, 0x52, 0x06, 0x6c, 0x61, 0x62, 0x65, 0x6c, 0x73, 0x12, 0x1c, 0x0a,
	0x0a, 0x6b, 0x6d, 0x73, 0x5f, 0x6b, 0x65, 0x79, 0x5f, 0x69, 0x64, 0x18, 0x07, 0x20, 0x01, 0x28,
	0x09, 0x52, 0x08, 0x6b, 0x6d, 0x73, 0x4b, 0x65, 0x79, 0x49, 0x64, 0x12, 0x3e, 0x0a, 0x06, 0x73,
	0x74, 0x61, 0x74, 0x75, 0x73, 0x18, 0x08, 0x20, 0x01, 0x28, 0x0e, 0x32, 0x26, 0x2e, 0x79, 0x61,
	0x6e, 0x64, 0x65, 0x78, 0x2e, 0x63, 0x6c, 0x6f, 0x75, 0x64, 0x2e, 0x6c, 0x6f, 0x63, 0x6b, 0x62,
	0x6f, 0x78, 0x2e, 0x76, 0x31, 0x2e, 0x53, 0x65, 0x63, 0x72, 0x65, 0x74, 0x2e, 0x53, 0x74, 0x61,
	0x74, 0x75, 0x73, 0x52, 0x06, 0x73, 0x74, 0x61, 0x74, 0x75, 0x73, 0x12, 0x49, 0x0a, 0x0f, 0x63,
	0x75, 0x72, 0x72, 0x65, 0x6e, 0x74, 0x5f, 0x76, 0x65, 0x72, 0x73, 0x69, 0x6f, 0x6e, 0x18, 0x09,
	0x20, 0x01, 0x28, 0x0b, 0x32, 0x20, 0x2e, 0x79, 0x61, 0x6e, 0x64, 0x65, 0x78, 0x2e, 0x63, 0x6c,
	0x6f, 0x75, 0x64, 0x2e, 0x6c, 0x6f, 0x63, 0x6b, 0x62, 0x6f, 0x78, 0x2e, 0x76, 0x31, 0x2e, 0x56,
	0x65, 0x72, 0x73, 0x69, 0x6f, 0x6e, 0x52, 0x0e, 0x63, 0x75, 0x72, 0x72, 0x65, 0x6e, 0x74, 0x56,
	0x65, 0x72, 0x73, 0x69, 0x6f, 0x6e, 0x12, 0x2f, 0x0a, 0x13, 0x64, 0x65, 0x6c, 0x65, 0x74, 0x69,
	0x6f, 0x6e, 0x5f, 0x70, 0x72, 0x6f, 0x74, 0x65, 0x63, 0x74, 0x69, 0x6f, 0x6e, 0x18, 0x0a, 0x20,
	0x01, 0x28, 0x08, 0x52, 0x12, 0x64, 0x65, 0x6c, 0x65, 0x74, 0x69, 0x6f, 0x6e, 0x50, 0x72, 0x6f,
	0x74, 0x65, 0x63, 0x74, 0x69, 0x6f, 0x6e, 0x12, 0x7d, 0x0a, 0x1e, 0x70, 0x61, 0x73, 0x73, 0x77,
	0x6f, 0x72, 0x64, 0x5f, 0x70, 0x61, 0x79, 0x6c, 0x6f, 0x61, 0x64, 0x5f, 0x73, 0x70, 0x65, 0x63,
	0x69, 0x66, 0x69, 0x63, 0x61, 0x74, 0x69, 0x6f, 0x6e, 0x18, 0x0b, 0x20, 0x01, 0x28, 0x0b, 0x32,
	0x35, 0x2e, 0x79, 0x61, 0x6e, 0x64, 0x65, 0x78, 0x2e, 0x63, 0x6c, 0x6f, 0x75, 0x64, 0x2e, 0x6c,
	0x6f, 0x63, 0x6b, 0x62, 0x6f, 0x78, 0x2e, 0x76, 0x31, 0x2e, 0x50, 0x61, 0x73, 0x73, 0x77, 0x6f,
	0x72, 0x64, 0x50, 0x61, 0x79, 0x6c, 0x6f, 0x61, 0x64, 0x53, 0x70, 0x65, 0x63, 0x69, 0x66, 0x69,
	0x63, 0x61, 0x74, 0x69, 0x6f, 0x6e, 0x48, 0x00, 0x52, 0x1c, 0x70, 0x61, 0x73, 0x73, 0x77, 0x6f,
	0x72, 0x64, 0x50, 0x61, 0x79, 0x6c, 0x6f, 0x61, 0x64, 0x53, 0x70, 0x65, 0x63, 0x69, 0x66, 0x69,
	0x63, 0x61, 0x74, 0x69, 0x6f, 0x6e, 0x1a, 0x39, 0x0a, 0x0b, 0x4c, 0x61, 0x62, 0x65, 0x6c, 0x73,
	0x45, 0x6e, 0x74, 0x72, 0x79, 0x12, 0x10, 0x0a, 0x03, 0x6b, 0x65, 0x79, 0x18, 0x01, 0x20, 0x01,
	0x28, 0x09, 0x52, 0x03, 0x6b, 0x65, 0x79, 0x12, 0x14, 0x0a, 0x05, 0x76, 0x61, 0x6c, 0x75, 0x65,
	0x18, 0x02, 0x20, 0x01, 0x28, 0x09, 0x52, 0x05, 0x76, 0x61, 0x6c, 0x75, 0x65, 0x3a, 0x02, 0x38,
	0x01, 0x22, 0x48, 0x0a, 0x06, 0x53, 0x74, 0x61, 0x74, 0x75, 0x73, 0x12, 0x16, 0x0a, 0x12, 0x53,
	0x54, 0x41, 0x54, 0x55, 0x53, 0x5f, 0x55, 0x4e, 0x53, 0x50, 0x45, 0x43, 0x49, 0x46, 0x49, 0x45,
	0x44, 0x10, 0x00, 0x12, 0x0c, 0x0a, 0x08, 0x43, 0x52, 0x45, 0x41, 0x54, 0x49, 0x4e, 0x47, 0x10,
	0x01, 0x12, 0x0a, 0x0a, 0x06, 0x41, 0x43, 0x54, 0x49, 0x56, 0x45, 0x10, 0x02, 0x12, 0x0c, 0x0a,
	0x08, 0x49, 0x4e, 0x41, 0x43, 0x54, 0x49, 0x56, 0x45, 0x10, 0x03, 0x42, 0x17, 0x0a, 0x15, 0x70,
	0x61, 0x79, 0x6c, 0x6f, 0x61, 0x64, 0x5f, 0x73, 0x70, 0x65, 0x63, 0x69, 0x66, 0x69, 0x63, 0x61,
	0x74, 0x69, 0x6f, 0x6e, 0x22, 0xb1, 0x04, 0x0a, 0x07, 0x56, 0x65, 0x72, 0x73, 0x69, 0x6f, 0x6e,
	0x12, 0x0e, 0x0a, 0x02, 0x69, 0x64, 0x18, 0x01, 0x20, 0x01, 0x28, 0x09, 0x52, 0x02, 0x69, 0x64,
	0x12, 0x1b, 0x0a, 0x09, 0x73, 0x65, 0x63, 0x72, 0x65, 0x74, 0x5f, 0x69, 0x64, 0x18, 0x02, 0x20,
	0x01, 0x28, 0x09, 0x52, 0x08, 0x73, 0x65, 0x63, 0x72, 0x65, 0x74, 0x49, 0x64, 0x12, 0x39, 0x0a,
	0x0a, 0x63, 0x72, 0x65, 0x61, 0x74, 0x65, 0x64, 0x5f, 0x61, 0x74, 0x18, 0x03, 0x20, 0x01, 0x28,
	0x0b, 0x32, 0x1a, 0x2e, 0x67, 0x6f, 0x6f, 0x67, 0x6c, 0x65, 0x2e, 0x70, 0x72, 0x6f, 0x74, 0x6f,
	0x62, 0x75, 0x66, 0x2e, 0x54, 0x69, 0x6d, 0x65, 0x73, 0x74, 0x61, 0x6d, 0x70, 0x52, 0x09, 0x63,
	0x72, 0x65, 0x61, 0x74, 0x65, 0x64, 0x41, 0x74, 0x12, 0x39, 0x0a, 0x0a, 0x64, 0x65, 0x73, 0x74,
	0x72, 0x6f, 0x79, 0x5f, 0x61, 0x74, 0x18, 0x04, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x1a, 0x2e, 0x67,
	0x6f, 0x6f, 0x67, 0x6c, 0x65, 0x2e, 0x70, 0x72, 0x6f, 0x74, 0x6f, 0x62, 0x75, 0x66, 0x2e, 0x54,
	0x69, 0x6d, 0x65, 0x73, 0x74, 0x61, 0x6d, 0x70, 0x52, 0x09, 0x64, 0x65, 0x73, 0x74, 0x72, 0x6f,
	0x79, 0x41, 0x74, 0x12, 0x20, 0x0a, 0x0b, 0x64, 0x65, 0x73, 0x63, 0x72, 0x69, 0x70, 0x74, 0x69,
	0x6f, 0x6e, 0x18, 0x05, 0x20, 0x01, 0x28, 0x09, 0x52, 0x0b, 0x64, 0x65, 0x73, 0x63, 0x72, 0x69,
	0x70, 0x74, 0x69, 0x6f, 0x6e, 0x12, 0x3f, 0x0a, 0x06, 0x73, 0x74, 0x61, 0x74, 0x75, 0x73, 0x18,
	0x06, 0x20, 0x01, 0x28, 0x0e, 0x32, 0x27, 0x2e, 0x79, 0x61, 0x6e, 0x64, 0x65, 0x78, 0x2e, 0x63,
	0x6c, 0x6f, 0x75, 0x64, 0x2e, 0x6c, 0x6f, 0x63, 0x6b, 0x62, 0x6f, 0x78, 0x2e, 0x76, 0x31, 0x2e,
	0x56, 0x65, 0x72, 0x73, 0x69, 0x6f, 0x6e, 0x2e, 0x53, 0x74, 0x61, 0x74, 0x75, 0x73, 0x52, 0x06,
	0x73, 0x74, 0x61, 0x74, 0x75, 0x73, 0x12, 0x2c, 0x0a, 0x12, 0x70, 0x61, 0x79, 0x6c, 0x6f, 0x61,
	0x64, 0x5f, 0x65, 0x6e, 0x74, 0x72, 0x79, 0x5f, 0x6b, 0x65, 0x79, 0x73, 0x18, 0x07, 0x20, 0x03,
	0x28, 0x09, 0x52, 0x10, 0x70, 0x61, 0x79, 0x6c, 0x6f, 0x61, 0x64, 0x45, 0x6e, 0x74, 0x72, 0x79,
	0x4b, 0x65, 0x79, 0x73, 0x12, 0x7d, 0x0a, 0x1e, 0x70, 0x61, 0x73, 0x73, 0x77, 0x6f, 0x72, 0x64,
	0x5f, 0x70, 0x61, 0x79, 0x6c, 0x6f, 0x61, 0x64, 0x5f, 0x73, 0x70, 0x65, 0x63, 0x69, 0x66, 0x69,
	0x63, 0x61, 0x74, 0x69, 0x6f, 0x6e, 0x18, 0x08, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x35, 0x2e, 0x79,
	0x61, 0x6e, 0x64, 0x65, 0x78, 0x2e, 0x63, 0x6c, 0x6f, 0x75, 0x64, 0x2e, 0x6c, 0x6f, 0x63, 0x6b,
	0x62, 0x6f, 0x78, 0x2e, 0x76, 0x31, 0x2e, 0x50, 0x61, 0x73, 0x73, 0x77, 0x6f, 0x72, 0x64, 0x50,
	0x61, 0x79, 0x6c, 0x6f, 0x61, 0x64, 0x53, 0x70, 0x65, 0x63, 0x69, 0x66, 0x69, 0x63, 0x61, 0x74,
	0x69, 0x6f, 0x6e, 0x48, 0x00, 0x52, 0x1c, 0x70, 0x61, 0x73, 0x73, 0x77, 0x6f, 0x72, 0x64, 0x50,
	0x61, 0x79, 0x6c, 0x6f, 0x61, 0x64, 0x53, 0x70, 0x65, 0x63, 0x69, 0x66, 0x69, 0x63, 0x61, 0x74,
	0x69, 0x6f, 0x6e, 0x22, 0x5a, 0x0a, 0x06, 0x53, 0x74, 0x61, 0x74, 0x75, 0x73, 0x12, 0x16, 0x0a,
	0x12, 0x53, 0x54, 0x41, 0x54, 0x55, 0x53, 0x5f, 0x55, 0x4e, 0x53, 0x50, 0x45, 0x43, 0x49, 0x46,
	0x49, 0x45, 0x44, 0x10, 0x00, 0x12, 0x0a, 0x0a, 0x06, 0x41, 0x43, 0x54, 0x49, 0x56, 0x45, 0x10,
	0x01, 0x12, 0x1d, 0x0a, 0x19, 0x53, 0x43, 0x48, 0x45, 0x44, 0x55, 0x4c, 0x45, 0x44, 0x5f, 0x46,
	0x4f, 0x52, 0x5f, 0x44, 0x45, 0x53, 0x54, 0x52, 0x55, 0x43, 0x54, 0x49, 0x4f, 0x4e, 0x10, 0x02,
	0x12, 0x0d, 0x0a, 0x09, 0x44, 0x45, 0x53, 0x54, 0x52, 0x4f, 0x59, 0x45, 0x44, 0x10, 0x03, 0x42,
	0x17, 0x0a, 0x15, 0x70, 0x61, 0x79, 0x6c, 0x6f, 0x61, 0x64, 0x5f, 0x73, 0x70, 0x65, 0x63, 0x69,
	0x66, 0x69, 0x63, 0x61, 0x74, 0x69, 0x6f, 0x6e, 0x22, 0xa6, 0x04, 0x0a, 0x1c, 0x50, 0x61, 0x73,
	0x73, 0x77, 0x6f, 0x72, 0x64, 0x50, 0x61, 0x79, 0x6c, 0x6f, 0x61, 0x64, 0x53, 0x70, 0x65, 0x63,
	0x69, 0x66, 0x69, 0x63, 0x61, 0x74, 0x69, 0x6f, 0x6e, 0x12, 0x47, 0x0a, 0x0c, 0x70, 0x61, 0x73,
	0x73, 0x77, 0x6f, 0x72, 0x64, 0x5f, 0x6b, 0x65, 0x79, 0x18, 0x01, 0x20, 0x01, 0x28, 0x09, 0x42,
	0x24, 0xe8, 0xc7, 0x31, 0x01, 0xf2, 0xc7, 0x31, 0x13, 0x5b, 0x2d, 0x5f, 0x2e, 0x2f, 0x5c, 0x5c,
	0x40, 0x30, 0x2d, 0x39, 0x61, 0x2d, 0x7a, 0x41, 0x2d, 0x5a, 0x5d, 0x2b, 0x8a, 0xc8, 0x31, 0x05,
	0x3c, 0x3d, 0x32, 0x35, 0x36, 0x52, 0x0b, 0x70, 0x61, 0x73, 0x73, 0x77, 0x6f, 0x72, 0x64, 0x4b,
	0x65, 0x79, 0x12, 0x21, 0x0a, 0x06, 0x6c, 0x65, 0x6e, 0x67, 0x74, 0x68, 0x18, 0x02, 0x20, 0x01,
	0x28, 0x03, 0x42, 0x09, 0xfa, 0xc7, 0x31, 0x05, 0x3c, 0x3d, 0x32, 0x35, 0x36, 0x52, 0x06, 0x6c,
	0x65, 0x6e, 0x67, 0x74, 0x68, 0x12, 0x47, 0x0a, 0x11, 0x69, 0x6e, 0x63, 0x6c, 0x75, 0x64, 0x65,
	0x5f, 0x75, 0x70, 0x70, 0x65, 0x72, 0x63, 0x61, 0x73, 0x65, 0x18, 0x03, 0x20, 0x01, 0x28, 0x0b,
	0x32, 0x1a, 0x2e, 0x67, 0x6f, 0x6f, 0x67, 0x6c, 0x65, 0x2e, 0x70, 0x72, 0x6f, 0x74, 0x6f, 0x62,
	0x75, 0x66, 0x2e, 0x42, 0x6f, 0x6f, 0x6c, 0x56, 0x61, 0x6c, 0x75, 0x65, 0x52, 0x10, 0x69, 0x6e,
	0x63, 0x6c, 0x75, 0x64, 0x65, 0x55, 0x70, 0x70, 0x65, 0x72, 0x63, 0x61, 0x73, 0x65, 0x12, 0x47,
	0x0a, 0x11, 0x69, 0x6e, 0x63, 0x6c, 0x75, 0x64, 0x65, 0x5f, 0x6c, 0x6f, 0x77, 0x65, 0x72, 0x63,
	0x61, 0x73, 0x65, 0x18, 0x04, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x1a, 0x2e, 0x67, 0x6f, 0x6f, 0x67,
	0x6c, 0x65, 0x2e, 0x70, 0x72, 0x6f, 0x74, 0x6f, 0x62, 0x75, 0x66, 0x2e, 0x42, 0x6f, 0x6f, 0x6c,
	0x56, 0x61, 0x6c, 0x75, 0x65, 0x52, 0x10, 0x69, 0x6e, 0x63, 0x6c, 0x75, 0x64, 0x65, 0x4c, 0x6f,
	0x77, 0x65, 0x72, 0x63, 0x61, 0x73, 0x65, 0x12, 0x41, 0x0a, 0x0e, 0x69, 0x6e, 0x63, 0x6c, 0x75,
	0x64, 0x65, 0x5f, 0x64, 0x69, 0x67, 0x69, 0x74, 0x73, 0x18, 0x05, 0x20, 0x01, 0x28, 0x0b, 0x32,
	0x1a, 0x2e, 0x67, 0x6f, 0x6f, 0x67, 0x6c, 0x65, 0x2e, 0x70, 0x72, 0x6f, 0x74, 0x6f, 0x62, 0x75,
	0x66, 0x2e, 0x42, 0x6f, 0x6f, 0x6c, 0x56, 0x61, 0x6c, 0x75, 0x65, 0x52, 0x0d, 0x69, 0x6e, 0x63,
	0x6c, 0x75, 0x64, 0x65, 0x44, 0x69, 0x67, 0x69, 0x74, 0x73, 0x12, 0x4b, 0x0a, 0x13, 0x69, 0x6e,
	0x63, 0x6c, 0x75, 0x64, 0x65, 0x5f, 0x70, 0x75, 0x6e, 0x63, 0x74, 0x75, 0x61, 0x74, 0x69, 0x6f,
	0x6e, 0x18, 0x06, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x1a, 0x2e, 0x67, 0x6f, 0x6f, 0x67, 0x6c, 0x65,
	0x2e, 0x70, 0x72, 0x6f, 0x74, 0x6f, 0x62, 0x75, 0x66, 0x2e, 0x42, 0x6f, 0x6f, 0x6c, 0x56, 0x61,
	0x6c, 0x75, 0x65, 0x52, 0x12, 0x69, 0x6e, 0x63, 0x6c, 0x75, 0x64, 0x65, 0x50, 0x75, 0x6e, 0x63,
	0x74, 0x75, 0x61, 0x74, 0x69, 0x6f, 0x6e, 0x12, 0x3b, 0x0a, 0x14, 0x69, 0x6e, 0x63, 0x6c, 0x75,
	0x64, 0x65, 0x64, 0x5f, 0x70, 0x75, 0x6e, 0x63, 0x74, 0x75, 0x61, 0x74, 0x69, 0x6f, 0x6e, 0x18,
	0x07, 0x20, 0x01, 0x28, 0x09, 0x42, 0x08, 0x8a, 0xc8, 0x31, 0x04, 0x3c, 0x3d, 0x33, 0x32, 0x52,
	0x13, 0x69, 0x6e, 0x63, 0x6c, 0x75, 0x64, 0x65, 0x64, 0x50, 0x75, 0x6e, 0x63, 0x74, 0x75, 0x61,
	0x74, 0x69, 0x6f, 0x6e, 0x12, 0x3b, 0x0a, 0x14, 0x65, 0x78, 0x63, 0x6c, 0x75, 0x64, 0x65, 0x64,
	0x5f, 0x70, 0x75, 0x6e, 0x63, 0x74, 0x75, 0x61, 0x74, 0x69, 0x6f, 0x6e, 0x18, 0x08, 0x20, 0x01,
	0x28, 0x09, 0x42, 0x08, 0x8a, 0xc8, 0x31, 0x04, 0x3c, 0x3d, 0x33, 0x31, 0x52, 0x13, 0x65, 0x78,
	0x63, 0x6c, 0x75, 0x64, 0x65, 0x64, 0x50, 0x75, 0x6e, 0x63, 0x74, 0x75, 0x61, 0x74, 0x69, 0x6f,
	0x6e, 0x42, 0x62, 0x0a, 0x1b, 0x79, 0x61, 0x6e, 0x64, 0x65, 0x78, 0x2e, 0x63, 0x6c, 0x6f, 0x75,
	0x64, 0x2e, 0x61, 0x70, 0x69, 0x2e, 0x6c, 0x6f, 0x63, 0x6b, 0x62, 0x6f, 0x78, 0x2e, 0x76, 0x31,
	0x5a, 0x43, 0x67, 0x69, 0x74, 0x68, 0x75, 0x62, 0x2e, 0x63, 0x6f, 0x6d, 0x2f, 0x79, 0x61, 0x6e,
	0x64, 0x65, 0x78, 0x2d, 0x63, 0x6c, 0x6f, 0x75, 0x64, 0x2f, 0x67, 0x6f, 0x2d, 0x67, 0x65, 0x6e,
	0x70, 0x72, 0x6f, 0x74, 0x6f, 0x2f, 0x79, 0x61, 0x6e, 0x64, 0x65, 0x78, 0x2f, 0x63, 0x6c, 0x6f,
	0x75, 0x64, 0x2f, 0x6c, 0x6f, 0x63, 0x6b, 0x62, 0x6f, 0x78, 0x2f, 0x76, 0x31, 0x3b, 0x6c, 0x6f,
	0x63, 0x6b, 0x62, 0x6f, 0x78, 0x62, 0x06, 0x70, 0x72, 0x6f, 0x74, 0x6f, 0x33,
}

var (
	file_yandex_cloud_lockbox_v1_secret_proto_rawDescOnce sync.Once
	file_yandex_cloud_lockbox_v1_secret_proto_rawDescData = file_yandex_cloud_lockbox_v1_secret_proto_rawDesc
)

func file_yandex_cloud_lockbox_v1_secret_proto_rawDescGZIP() []byte {
	file_yandex_cloud_lockbox_v1_secret_proto_rawDescOnce.Do(func() {
		file_yandex_cloud_lockbox_v1_secret_proto_rawDescData = protoimpl.X.CompressGZIP(file_yandex_cloud_lockbox_v1_secret_proto_rawDescData)
	})
	return file_yandex_cloud_lockbox_v1_secret_proto_rawDescData
}

var file_yandex_cloud_lockbox_v1_secret_proto_enumTypes = make([]protoimpl.EnumInfo, 2)
var file_yandex_cloud_lockbox_v1_secret_proto_msgTypes = make([]protoimpl.MessageInfo, 4)
var file_yandex_cloud_lockbox_v1_secret_proto_goTypes = []any{
	(Secret_Status)(0),                   // 0: yandex.cloud.lockbox.v1.Secret.Status
	(Version_Status)(0),                  // 1: yandex.cloud.lockbox.v1.Version.Status
	(*Secret)(nil),                       // 2: yandex.cloud.lockbox.v1.Secret
	(*Version)(nil),                      // 3: yandex.cloud.lockbox.v1.Version
	(*PasswordPayloadSpecification)(nil), // 4: yandex.cloud.lockbox.v1.PasswordPayloadSpecification
	nil,                                  // 5: yandex.cloud.lockbox.v1.Secret.LabelsEntry
	(*timestamppb.Timestamp)(nil),        // 6: google.protobuf.Timestamp
	(*wrapperspb.BoolValue)(nil),         // 7: google.protobuf.BoolValue
}
var file_yandex_cloud_lockbox_v1_secret_proto_depIdxs = []int32{
	6,  // 0: yandex.cloud.lockbox.v1.Secret.created_at:type_name -> google.protobuf.Timestamp
	5,  // 1: yandex.cloud.lockbox.v1.Secret.labels:type_name -> yandex.cloud.lockbox.v1.Secret.LabelsEntry
	0,  // 2: yandex.cloud.lockbox.v1.Secret.status:type_name -> yandex.cloud.lockbox.v1.Secret.Status
	3,  // 3: yandex.cloud.lockbox.v1.Secret.current_version:type_name -> yandex.cloud.lockbox.v1.Version
	4,  // 4: yandex.cloud.lockbox.v1.Secret.password_payload_specification:type_name -> yandex.cloud.lockbox.v1.PasswordPayloadSpecification
	6,  // 5: yandex.cloud.lockbox.v1.Version.created_at:type_name -> google.protobuf.Timestamp
	6,  // 6: yandex.cloud.lockbox.v1.Version.destroy_at:type_name -> google.protobuf.Timestamp
	1,  // 7: yandex.cloud.lockbox.v1.Version.status:type_name -> yandex.cloud.lockbox.v1.Version.Status
	4,  // 8: yandex.cloud.lockbox.v1.Version.password_payload_specification:type_name -> yandex.cloud.lockbox.v1.PasswordPayloadSpecification
	7,  // 9: yandex.cloud.lockbox.v1.PasswordPayloadSpecification.include_uppercase:type_name -> google.protobuf.BoolValue
	7,  // 10: yandex.cloud.lockbox.v1.PasswordPayloadSpecification.include_lowercase:type_name -> google.protobuf.BoolValue
	7,  // 11: yandex.cloud.lockbox.v1.PasswordPayloadSpecification.include_digits:type_name -> google.protobuf.BoolValue
	7,  // 12: yandex.cloud.lockbox.v1.PasswordPayloadSpecification.include_punctuation:type_name -> google.protobuf.BoolValue
	13, // [13:13] is the sub-list for method output_type
	13, // [13:13] is the sub-list for method input_type
	13, // [13:13] is the sub-list for extension type_name
	13, // [13:13] is the sub-list for extension extendee
	0,  // [0:13] is the sub-list for field type_name
}

func init() { file_yandex_cloud_lockbox_v1_secret_proto_init() }
func file_yandex_cloud_lockbox_v1_secret_proto_init() {
	if File_yandex_cloud_lockbox_v1_secret_proto != nil {
		return
	}
	if !protoimpl.UnsafeEnabled {
		file_yandex_cloud_lockbox_v1_secret_proto_msgTypes[0].Exporter = func(v any, i int) any {
			switch v := v.(*Secret); i {
			case 0:
				return &v.state
			case 1:
				return &v.sizeCache
			case 2:
				return &v.unknownFields
			default:
				return nil
			}
		}
		file_yandex_cloud_lockbox_v1_secret_proto_msgTypes[1].Exporter = func(v any, i int) any {
			switch v := v.(*Version); i {
			case 0:
				return &v.state
			case 1:
				return &v.sizeCache
			case 2:
				return &v.unknownFields
			default:
				return nil
			}
		}
		file_yandex_cloud_lockbox_v1_secret_proto_msgTypes[2].Exporter = func(v any, i int) any {
			switch v := v.(*PasswordPayloadSpecification); i {
			case 0:
				return &v.state
			case 1:
				return &v.sizeCache
			case 2:
				return &v.unknownFields
			default:
				return nil
			}
		}
	}
	file_yandex_cloud_lockbox_v1_secret_proto_msgTypes[0].OneofWrappers = []any{
		(*Secret_PasswordPayloadSpecification)(nil),
	}
	file_yandex_cloud_lockbox_v1_secret_proto_msgTypes[1].OneofWrappers = []any{
		(*Version_PasswordPayloadSpecification)(nil),
	}
	type x struct{}
	out := protoimpl.TypeBuilder{
		File: protoimpl.DescBuilder{
			GoPackagePath: reflect.TypeOf(x{}).PkgPath(),
			RawDescriptor: file_yandex_cloud_lockbox_v1_secret_proto_rawDesc,
			NumEnums:      2,
			NumMessages:   4,
			NumExtensions: 0,
			NumServices:   0,
		},
		GoTypes:           file_yandex_cloud_lockbox_v1_secret_proto_goTypes,
		DependencyIndexes: file_yandex_cloud_lockbox_v1_secret_proto_depIdxs,
		EnumInfos:         file_yandex_cloud_lockbox_v1_secret_proto_enumTypes,
		MessageInfos:      file_yandex_cloud_lockbox_v1_secret_proto_msgTypes,
	}.Build()
	File_yandex_cloud_lockbox_v1_secret_proto = out.File
	file_yandex_cloud_lockbox_v1_secret_proto_rawDesc = nil
	file_yandex_cloud_lockbox_v1_secret_proto_goTypes = nil
	file_yandex_cloud_lockbox_v1_secret_proto_depIdxs = nil
}
